<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2013 IMIA net based solutions (d.frerich@imia.de)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

namespace IMIA\ImiaPageteaser\Xclass;

/**
 * @package     imia_pageteaser
 * @subpackage  Utility
 * @author      David Frerich <d.frerich@imia.de>
 */
class PageRepository extends \TYPO3\CMS\Frontend\Page\PageRepository
{
    protected $externalDoktypes = array(103, 112, 113, 123, 133, 143);

	/**
	 * @param array $pagerow
	 * @param boolean $disable
	 * @return string
	 */
	public function getExtURL($pagerow, $disable = 0)
    {
		if (in_array($pagerow['doktype'], $this->shortcutDoktypes) && !$disable) {
			$redirectTo = $this->urltypes[$pagerow['urltype']] . $pagerow['url'];
			// If relative path, prefix Site URL:
			$uI = parse_url($redirectTo);
			// Relative path assumed now.
			if (!$uI['scheme'] && substr($redirectTo, 0, 1) != '/') {
				$redirectTo = \TYPO3\CMS\Core\Utility\GeneralUtility::getIndpEnv('TYPO3_SITE_URL') . $redirectTo;
			}

			return $redirectTo;
		} else {
            return parent::getExtURL($pagerow, $disable);
        }
	}
}